# Class FilterHeaderRowDirective

#### Hierarchy

- FormDirective
  - FilterHeaderRowDirective

#### Implements

- OnInit
- OnDestroy

- Defined in packages/angular/material/table-system/src/lib/table-filter/filter-header-row.directive.ts:38

#####
Index

### Constructors

constructor

### Properties

_formDefinition
cdr
context
directives
form
formDefinitionBuilder
initial?
invalidSubmit
loaded$
loadFailedMethod
loading$
loadingError$
loadingIndicatorService
loadMethod
loadSuccessfulMethod
name
ngSubmit
rxapSubmit
submitError$
submitFailedMethod
submitMethod
submitSuccessful$
submitSuccessfulMethod
submitting$
ɵdir
ɵfac

### Accessors

asyncValidator
control
dirty
disabled
enabled
errors
formDefinition
formDirective
invalid
loaded
loading
loadingError
path
pending
pristine
status
statusChanges
submitError
submitted
submitting
touched
untouched
useFormDefinition
valid
validator
value
valueChanges

### Methods

addControl
addFormArray
addFormGroup
getControl
getError
getFormArray
getFormGroup
getSubmitValue
hasError
loadFailed
loadInitialState
loadSuccessful
ngOnChanges
ngOnDestroy
ngOnInit
onReset
onSubmit
removeControl
removeFormArray
removeFormGroup
reset
resetForm
submit
submitFailed
submitSuccessful
updateModel

##
Constructors

### constructor

- new FilterHeaderRowDirective(
  tableFilter: TableFilterService,
  cdr: ChangeDetectorRef,
  formDefinition: null | FormDefinition<any, any, any>,
  ): FilterHeaderRowDirective

  #### Parameters

  - tableFilter: TableFilterService
  - cdr: ChangeDetectorRef
  - formDefinition: null | FormDefinition<any, any, any>

  #### Returns FilterHeaderRowDirective

  Overrides FormDirective.constructor

  - Defined in packages/angular/material/table-system/src/lib/table-filter/filter-header-row.directive.ts:52

##
Properties

### `Protected`_formDefinition

_formDefinition: FormDefinition<any>

Inherited from FormDirective._formDefinition

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:183

### `Readonly` cdr

cdr: ChangeDetectorRef

Inherited from FormDirective.cdr

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:206

### `Readonly` context

context: InputSignal<Record<string, unknown>> = ...

Inherited from FormDirective.context

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:121

### directives

directives: FormControlName[]

#### Description

Tracks the list of added `FormControlName` instances

Inherited from FormDirective.directives

- Defined in node_modules/@angular/forms/index.d.ts:2915

### form

form: RxapFormGroup<any>

#### Description

Tracks the `FormGroup` bound to this directive.

Inherited from FormDirective.form

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:116

### `Protected` `Readonly` formDefinitionBuilder

formDefinitionBuilder: null | RxapFormBuilder<any, FormType<any>> = null

Inherited from FormDirective.formDefinitionBuilder

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:244

### `Optional` initial

initial?: any

Inherited from FormDirective.initial

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:119

### invalidSubmit

invalidSubmit: EventEmitter<Record<string, any>> = ...

Inherited from FormDirective.invalidSubmit

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:134

### `Readonly` loaded$

loaded$: ToggleSubject = ...

Inherited from FormDirective.loaded$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:180

### loadFailedMethod

loadFailedMethod: null | FormLoadFailedMethod = null

Inherited from FormDirective.loadFailedMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:192

### `Readonly` loading$

loading$: ToggleSubject = ...

Inherited from FormDirective.loading$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:179

### `Readonly` loadingError$

loadingError$: BehaviorSubject<null | Error> = ...

Inherited from FormDirective.loadingError$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:181

### `Protected` `Readonly` loadingIndicatorService

loadingIndicatorService: null | LoadingIndicatorService = null

Inherited from FormDirective.loadingIndicatorService

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:247

### loadMethod

loadMethod: null | FormLoadMethod<any> = null

Inherited from FormDirective.loadMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:189

### loadSuccessfulMethod

loadSuccessfulMethod: null | FormLoadSuccessfulMethod<any> = null

Inherited from FormDirective.loadSuccessfulMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:195

### name

name: null | string | number

#### Description

The name for the control

Inherited from FormDirective.name

- Defined in node_modules/@angular/forms/index.d.ts:1205

### ngSubmit

ngSubmit: EventEmitter<any>

#### Description

Emits an event when the form submission has been triggered.

Inherited from FormDirective.ngSubmit

- Defined in node_modules/@angular/forms/index.d.ts:2925

### rxapSubmit

rxapSubmit: EventEmitter<any> = ...

Emits when the submit method is executed without errors. The result of the submit method is passed as event object.

If no submit method is defined then emit after the submit button is clicked.

Inherited from FormDirective.rxapSubmit

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:131

### `Readonly` submitError$

submitError$: BehaviorSubject<null | Error> = ...

Inherited from FormDirective.submitError$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:178

### submitFailedMethod

submitFailedMethod: null | FormSubmitFailedMethod = null

Inherited from FormDirective.submitFailedMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:198

### submitMethod

submitMethod: null | FormSubmitMethod<any> = null

Inherited from FormDirective.submitMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:186

### submitSuccessful$

submitSuccessful$: EventEmitter<any> = ...

Inherited from FormDirective.submitSuccessful$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:138

### submitSuccessfulMethod

submitSuccessfulMethod: null | FormSubmitSuccessfulMethod<any> = null

Inherited from FormDirective.submitSuccessfulMethod

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:201

### `Readonly` submitting$

submitting$: ToggleSubject = ...

Inherited from FormDirective.submitting$

- Defined in packages/angular/forms/src/lib/directives/form.directive.ts:177

### `Static` ɵdir

"ɵdir": unknown

Inherited from FormDirective.ɵdir

- Defined in node_modules/@angular/forms/index.d.ts:3042

### `Static` ɵfac

"ɵfac": unknown

Inherited from FormDirective.ɵfac

- Defined in node_modules/@angular/forms/index.d.ts:3041

##
Accessors

### asyncValidator

- get asyncValidator(): null | AsyncValidatorFn

  #### Returns null | AsyncValidatorFn

  #### Description

  Asynchronous validator function composed of all the asynchronous validators registered with this directive.

  Inherited from FormDirective.asyncValidator

  - Defined in node_modules/@angular/forms/index.d.ts:826

### control

- get control(): FormGroup

  #### Returns FormGroup

  #### Description

  Returns the `FormGroup` bound to this directive.

  Inherited from FormDirective.control

  - Defined in node_modules/@angular/forms/index.d.ts:2940

### dirty

- get dirty(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is dirty, meaning that the user has changed the value in the UI. If the control is not present, null is returned.

  Inherited from FormDirective.dirty

  - Defined in node_modules/@angular/forms/index.d.ts:766

### disabled

- get disabled(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is disabled, meaning that the control is disabled in the UI and is exempt from validation checks and excluded from aggregate values of ancestor controls. If the control is not present, null is returned.

  Inherited from FormDirective.disabled

  - Defined in node_modules/@angular/forms/index.d.ts:743

### enabled

- get enabled(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is enabled, meaning that the control is included in ancestor calculations of validity or value. If the control is not present, null is returned.

  Inherited from FormDirective.enabled

  - Defined in node_modules/@angular/forms/index.d.ts:749

### errors

- get errors(): null | ValidationErrors

  #### Returns null | ValidationErrors

  #### Description

  Reports the control's validation errors. If the control is not present, null is returned.

  Inherited from FormDirective.errors

  - Defined in node_modules/@angular/forms/index.d.ts:754

### formDefinition

- get formDefinition(): FormDefinition<T>

  #### Returns FormDefinition<T>

  Inherited from FormDirective.formDefinition

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:173

### formDirective

- get formDirective(): Form

  #### Returns Form

  #### Description

  Returns this directive's instance.

  Inherited from FormDirective.formDirective

  - Defined in node_modules/@angular/forms/index.d.ts:2935

### invalid

- get invalid(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is invalid, meaning that an error exists in the input value. If the control is not present, null is returned.

  Inherited from FormDirective.invalid

  - Defined in node_modules/@angular/forms/index.d.ts:729

### loaded

- get loaded(): boolean

  #### Returns boolean

  Inherited from FormDirective.loaded

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:156

### loading

- get loading(): boolean

  #### Returns boolean

  Inherited from FormDirective.loading

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:151

### loadingError

- get loadingError(): null | Error

  #### Returns null | Error

  Inherited from FormDirective.loadingError

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:161

### path

- get path(): string[]

  #### Returns string[]

  #### Description

  Returns an array representing the path to this group. Because this directive always lives at the top level of a form, it always an empty array.

  Inherited from FormDirective.path

  - Defined in node_modules/@angular/forms/index.d.ts:2946

### pending

- get pending(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether a control is pending, meaning that async validation is occurring and errors are not yet available for the input value. If the control is not present, null is returned.

  Inherited from FormDirective.pending

  - Defined in node_modules/@angular/forms/index.d.ts:736

### pristine

- get pristine(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is pristine, meaning that the user has not yet changed the value in the UI. If the control is not present, null is returned.

  Inherited from FormDirective.pristine

  - Defined in node_modules/@angular/forms/index.d.ts:760

### status

- get status(): null | string

  #### Returns null | string

  #### Description

  Reports the validation status of the control. Possible values include: 'VALID', 'INVALID', 'DISABLED', and 'PENDING'. If the control is not present, null is returned.

  Inherited from FormDirective.status

  - Defined in node_modules/@angular/forms/index.d.ts:779

### statusChanges

- get statusChanges(): null | Observable<any>

  #### Returns null | Observable<any>

  #### Description

  Returns a multicasting observable that emits a validation status whenever it is calculated for the control. If the control is not present, null is returned.

  Inherited from FormDirective.statusChanges

  - Defined in node_modules/@angular/forms/index.d.ts:791

### submitError

- get submitError(): null | Error

  #### Returns null | Error

  Inherited from FormDirective.submitError

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:146

### submitted

- get submitted(): boolean

  #### Returns boolean

  #### Description

  Reports whether the form submission has been triggered.

  Inherited from FormDirective.submitted

  - Defined in node_modules/@angular/forms/index.d.ts:2898
- set submitted(value: boolean): void

  #### Parameters

  - value: boolean

  #### Returns void

  Inherited from FormDirective.submitted

  - Defined in node_modules/@angular/forms/index.d.ts:2899

### submitting

- get submitting(): boolean

  #### Returns boolean

  Inherited from FormDirective.submitting

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:141

### touched

- get touched(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is touched, meaning that the user has triggered a `blur` event on it. If the control is not present, null is returned.

  Inherited from FormDirective.touched

  - Defined in node_modules/@angular/forms/index.d.ts:772

### untouched

- get untouched(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is untouched, meaning that the user has not yet triggered a `blur` event on it. If the control is not present, null is returned.

  Inherited from FormDirective.untouched

  - Defined in node_modules/@angular/forms/index.d.ts:785

### useFormDefinition

- set useFormDefinition(value: "" | FormDefinition<any, any, any>): void

  #### Parameters

  - value: "" | FormDefinition<any, any, any>

  #### Returns void

  Overrides FormDirective.useFormDefinition

  - Defined in packages/angular/material/table-system/src/lib/table-filter/filter-header-row.directive.ts:43

### valid

- get valid(): null | boolean

  #### Returns null | boolean

  #### Description

  Reports whether the control is valid. A control is considered valid if no validation errors exist with the current value. If the control is not present, null is returned.

  Inherited from FormDirective.valid

  - Defined in node_modules/@angular/forms/index.d.ts:723

### validator

- get validator(): null | ValidatorFn

  #### Returns null | ValidatorFn

  #### Description

  Synchronous validator function composed of all the synchronous validators registered with this directive.

  Inherited from FormDirective.validator

  - Defined in node_modules/@angular/forms/index.d.ts:820

### value

- get value(): any

  #### Returns any

  #### Description

  Reports the value of the control if it is present, otherwise null.

  Inherited from FormDirective.value

  - Defined in node_modules/@angular/forms/index.d.ts:716

### valueChanges

- get valueChanges(): null | Observable<any>

  #### Returns null | Observable<any>

  #### Description

  Returns a multicasting observable of value changes for the control that emits every time the value of the control changes in the UI or programmatically. If the control is not present, null is returned.

  Inherited from FormDirective.valueChanges

  - Defined in node_modules/@angular/forms/index.d.ts:798

##
Methods

### addControl

- addControl(dir: FormControlName): FormControl

  #### Parameters

  - dir: FormControlName

    The `FormControlName` directive instance.

  #### Returns FormControl

  #### Description

  Method that sets up the control directive in this group, re-calculates its value and validity, and adds the instance to the internal list of directives.

  Inherited from FormDirective.addControl

  - Defined in node_modules/@angular/forms/index.d.ts:2954

### addFormArray

- addFormArray(dir: FormArrayName): void

  Performs the necessary setup when a `FormArrayName` directive instance is added to the view.

  #### Parameters

  - dir: FormArrayName

    The `FormArrayName` directive instance.

  #### Returns void

  Inherited from FormDirective.addFormArray

  - Defined in node_modules/@angular/forms/index.d.ts:2994

### addFormGroup

- addFormGroup(dir: FormGroupName): void

  Adds a new `FormGroupName` directive instance to the form.

  #### Parameters

  - dir: FormGroupName

    The `FormGroupName` directive instance.

  #### Returns void

  Inherited from FormDirective.addFormGroup

  - Defined in node_modules/@angular/forms/index.d.ts:2974

### getControl

- getControl(dir: FormControlName): FormControl

  #### Parameters

  - dir: FormControlName

    The `FormControlName` directive instance.

  #### Returns FormControl

  #### Description

  Retrieves the `FormControl` instance from the provided `FormControlName` directive

  Inherited from FormDirective.getControl

  - Defined in node_modules/@angular/forms/index.d.ts:2961

### getError

- getError(errorCode: string, path?: string | (string | number)[]): any

  #### Parameters

  - errorCode: string

    The code of the error to check

  - `Optional` path: string | (string | number)[]

    A list of control names that designates how to move from the current control to the control that should be queried for errors.

  #### Returns any

  error data for that particular error. If the control or error is not present, null is returned.

  #### Description

  Reports error data for the control with the given path.

  #### Usage Notes

  For example, for the following `FormGroup`:

      form = new FormGroup({
        address: new FormGroup({ street: new FormControl() })
      });

  The path to the 'street' control from the root form would be 'address' -> 'street'.

  It can be provided to this method in one of two formats:

  1. An array of string control names, e.g. `['address', 'street']`
  2. A period-delimited list of control names in one string, e.g. `'address.street'`

  Inherited from FormDirective.getError

  - Defined in node_modules/@angular/forms/index.d.ts:891

### getFormArray

- getFormArray(dir: FormArrayName): FormArray

  #### Parameters

  - dir: FormArrayName

    The `FormArrayName` directive instance.

  #### Returns FormArray

  #### Description

  Retrieves the `FormArray` for a provided `FormArrayName` directive instance.

  Inherited from FormDirective.getFormArray

  - Defined in node_modules/@angular/forms/index.d.ts:3008

### getFormGroup

- getFormGroup(dir: FormGroupName): FormGroup

  #### Parameters

  - dir: FormGroupName

    The `FormGroupName` directive instance.

  #### Returns FormGroup

  #### Description

  Retrieves the `FormGroup` for a provided `FormGroupName` directive instance

  Inherited from FormDirective.getFormGroup

  - Defined in node_modules/@angular/forms/index.d.ts:2988

### `Protected` getSubmitValue

- getSubmitValue(): any

  #### Returns any

  Inherited from FormDirective.getSubmitValue

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:474

### hasError

- hasError(errorCode: string, path?: string | (string | number)[]): boolean

  #### Parameters

  - errorCode: string

    The code of the error to check

  - `Optional` path: string | (string | number)[]

    A list of control names that designates how to move from the current control to the control that should be queried for errors.

  #### Returns boolean

  whether the given error is present in the control at the given path.

  If the control is not present, false is returned.

  #### Description

  Reports whether the control with the given path has the error specified.

  #### Usage Notes

  For example, for the following `FormGroup`:

      form = new FormGroup({
        address: new FormGroup({ street: new FormControl() })
      });

  The path to the 'street' control from the root form would be 'address' -> 'street'.

  It can be provided to this method in one of two formats:

  1. An array of string control names, e.g. `['address', 'street']`
  2. A period-delimited list of control names in one string, e.g. `'address.street'`

  If no path is given, this method checks for the error on the current control.

  Inherited from FormDirective.hasError

  - Defined in node_modules/@angular/forms/index.d.ts:863

### `Protected` loadFailed

- loadFailed(error: Error): void

  #### Parameters

  - error: Error

  #### Returns void

  Inherited from FormDirective.loadFailed

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:464

### `Protected` loadInitialState

- loadInitialState(form: RxapFormGroup): void

  #### Parameters

  - form: RxapFormGroup

  #### Returns void

  Inherited from FormDirective.loadInitialState

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:404

### `Protected` loadSuccessful

- loadSuccessful(value: any): void

  #### Parameters

  - value: any

  #### Returns void

  Inherited from FormDirective.loadSuccessful

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:454

### ngOnChanges

- ngOnChanges(changes: SimpleChanges): void

  #### Parameters

  - changes: SimpleChanges

  #### Returns void

  #### Nodoc

  Inherited from FormDirective.ngOnChanges

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:267

### ngOnDestroy

- ngOnDestroy(): void

  #### Returns void

  Implementation of OnDestroy.ngOnDestroy

  Overrides FormDirective.ngOnDestroy

  - Defined in packages/angular/material/table-system/src/lib/table-filter/filter-header-row.directive.ts:75

### ngOnInit

- ngOnInit(): void

  #### Returns void

  Implementation of OnInit.ngOnInit

  Overrides FormDirective.ngOnInit

  - Defined in packages/angular/material/table-system/src/lib/table-filter/filter-header-row.directive.ts:62

### onReset

- onReset(): void

  #### Returns void

  #### Description

  Method called when the "reset" event is triggered on the form.

  Inherited from FormDirective.onReset

  - Defined in node_modules/@angular/forms/index.d.ts:3028

### onSubmit

- onSubmit($event: Event): boolean

  #### Parameters

  - $event: Event

    The "submit" event object

  #### Returns boolean

  #### Description

  Method called with the "submit" event is triggered on the form. Triggers the `ngSubmit` emitter to emit the "submit" event as its payload.

  Inherited from FormDirective.onSubmit

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:322

### removeControl

- removeControl(dir: FormControlName): void

  #### Parameters

  - dir: FormControlName

    The `FormControlName` directive instance.

  #### Returns void

  #### Description

  Removes the `FormControlName` instance from the internal list of directives

  Inherited from FormDirective.removeControl

  - Defined in node_modules/@angular/forms/index.d.ts:2968

### removeFormArray

- removeFormArray(dir: FormArrayName): void

  Performs the necessary cleanup when a `FormArrayName` directive instance is removed from the view.

  #### Parameters

  - dir: FormArrayName

    The `FormArrayName` directive instance.

  #### Returns void

  Inherited from FormDirective.removeFormArray

  - Defined in node_modules/@angular/forms/index.d.ts:3001

### removeFormGroup

- removeFormGroup(dir: FormGroupName): void

  Performs the necessary cleanup when a `FormGroupName` directive instance is removed from the view.

  #### Parameters

  - dir: FormGroupName

    The `FormGroupName` directive instance.

  #### Returns void

  Inherited from FormDirective.removeFormGroup

  - Defined in node_modules/@angular/forms/index.d.ts:2981

### reset

- reset(value?: any): void

  #### Parameters

  - `Optional` value: any

  #### Returns void

  #### Description

  Resets the control with the provided value if the control is present.

  Inherited from FormDirective.reset

  - Defined in node_modules/@angular/forms/index.d.ts:832

### resetForm

- resetForm(value?: any): void

  #### Parameters

  - `Optional` value: any

    The new value for the form.

  #### Returns void

  #### Description

  Resets the form to an initial value and resets its submitted status.

  Inherited from FormDirective.resetForm

  - Defined in node_modules/@angular/forms/index.d.ts:3035

### `Protected` submit

- submit(): void

  #### Returns void

  Inherited from FormDirective.submit

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:488

### `Protected` submitFailed

- submitFailed(error: Error): void

  #### Parameters

  - error: Error

  #### Returns void

  Inherited from FormDirective.submitFailed

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:534

### `Protected` submitSuccessful

- submitSuccessful(value: any): void

  #### Parameters

  - value: any

  #### Returns void

  Inherited from FormDirective.submitSuccessful

  - Defined in packages/angular/forms/src/lib/directives/form.directive.ts:547

### updateModel

- updateModel(dir: FormControlName, value: any): void

  Sets the new value for the provided `FormControlName` directive.

  #### Parameters

  - dir: FormControlName

    The `FormControlName` directive instance.

  - value: any

    The new value for the directive's control.

  #### Returns void

  Inherited from FormDirective.updateModel

  - Defined in node_modules/@angular/forms/index.d.ts:3015